#!/bin/sh  
#********************************************************************************
# Copyright © [2017] Unpublished Work of Novell, Inc. All Rights Reserved.
# THIS IS AN UNPUBLISHED WORK OF NOVELL, INC.  IT CONTAINS NOVELL'S CONFIDENTIAL, 
# PROPRIETARY, AND TRADE SECRET INFORMATION. NOVELL RESTRICTS THIS WORK TO NOVELL 
# EMPLOYEES WHO NEED THE WORK TO PERFORM  THEIR  ASSIGNMENTS AND TO THIRD PARTIES 
# AUTHORIZED BY NOVELL IN WRITING. THIS WORK MAY NOT BE USED,COPIED, DISTRIBUTED, 
# DISCLOSED,ADAPTED,PERFORMED,DISPLAYED,COLLECTED,COMPILED,  OR  LINKED   WITHOUT 
# NOVELL'S PRIOR WRITTEN CONSENT.  USE  OR  EXPLOITATION  OF  THIS  WORK  WITHOUT 
# AUTHORIZATION COULD SUBJECT  THE  PERPETRATOR  TO CRIMINAL AND  CIVIL LIABILITY
ipp_status_file="/var/opt/novell/iprintmobile/ipp_status.properties"
main()
{
	preInit "$@"
	
    if [ "$1" == "--init" ]; then
       disableIfRequired
    else
     	checkpermission
        if [[ "$1" == "--enable" ]]; then
    		enable
    	fi

    	if [[ "$1" == "--disable" ]]; then
    		disable
    	fi
    fi
    

}

checkpermission()
{
    read -r -p "Do you want to restart apache service?(y/n)" response
    case "$response" in
    [yY][eE][sS]|[yY]) 
        ;;
    *)
        exit
        ;;
	esac
}


usage()
{
	echo "This script is used to enable/disable ipp page."
	echo "Usage:" 
	echo "--disable   - disables ipp page"
	echo "--enable    - enables ipp page"
	exit 1
}

preInit()
{
	if [ $# -ne 1 ] || [ "$1" == "--help" ]; then
		usage    
		exit 0
	fi
	
	if [ "$1" != "--enable" ] && [ "$1" != "--disable" ]  && [ "$1" != "--init" ]; then
		usage
		exit 0
	fi
}

disableIfRequired(){
if [ -f "$ipp_status_file" ];then
    ipp_status=`awk -F "=" '{print $2}'  "$ipp_status_file"`
    if [ "$ipp_status" == "disabled" ]; then
        updateConfFileForDisable
    else
        echo "IPP Page is enabled by the Administrator"
    fi
    else
        echo "Disabling IPP page; /ipp will redirect to /print (iPrint Portal page)"
        updateConfFileForDisable
    fi
}

updateConfFileForDisable(){
    cp /etc/opt/novell/iprint/httpd/conf/iprint_g.conf  /etc/opt/novell/iprint/httpd/conf/iprint_g.conf.copy
    awk -f /opt/novell/iprintmobile/bin/modify-iprint-g-conf.awk -v disable=1 /etc/opt/novell/iprint/httpd/conf/iprint_g.conf.copy >/etc/opt/novell/iprint/httpd/conf/iprint_g.conf
    rm /etc/opt/novell/iprint/httpd/conf/iprint_g.conf.copy;
    echo "IPP Page status=disabled" > "$ipp_status_file"
    echo "IPP Page is disabled"
}

disable()
{
	updateConfFileForDisable
	echo "Restarting apache service"
	rcapache2 restart
}

enable()
{
	cp /etc/opt/novell/iprint/httpd/conf/iprint_g.conf  /etc/opt/novell/iprint/httpd/conf/iprint_g.conf.copy
	awk -f /opt/novell/iprintmobile/bin/modify-iprint-g-conf.awk -v disable=0 /etc/opt/novell/iprint/httpd/conf/iprint_g.conf.copy >/etc/opt/novell/iprint/httpd/conf/iprint_g.conf
	rm /etc/opt/novell/iprint/httpd/conf/iprint_g.conf.copy;
    echo "IPP Page status=enabled" > "$ipp_status_file"
    echo "IPP Page is enabled"
	echo "Restarting apache service"
	rcapache2 restart
}

main "$@"
